xref: /freebsd/tests/sys/acl/03.sh (revision abd87254)
1#!/bin/sh
2#
3# Copyright (c) 2008, 2009 Edward Tomasz Napierała <trasz@FreeBSD.org>
4#
5# Redistribution and use in source and binary forms, with or without
6# modification, are permitted provided that the following conditions
7# are met:
8# 1. Redistributions of source code must retain the above copyright
9#    notice, this list of conditions and the following disclaimer.
10# 2. Redistributions in binary form must reproduce the above copyright
11#    notice, this list of conditions and the following disclaimer in the
12#    documentation and/or other materials provided with the distribution.
13#
14# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24# SUCH DAMAGE.
25#
26#
27
28# This is a wrapper script to run tools-crossfs.test between UFS without
29# ACLs, UFS with POSIX.1e ACLs, and ZFS with NFSv4 ACLs.
30#
31# WARNING: It uses hardcoded ZFS pool name "acltools"
32#
33# Output should be obvious.
34
35if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
36	echo "1..0 # SKIP system doesn't have ZFS loaded"
37	exit 0
38fi
39if [ $(id -u) -ne 0 ]; then
40	echo "1..0 # SKIP you must be root"
41	exit 0
42fi
43if [ ! -c /dev/mdctl ]; then
44	echo "1..0 # SKIP no /dev/mdctl to create md devices"
45	exit 0
46fi
47
48echo "1..5"
49
50TESTDIR=$(dirname $(realpath $0))
51MNTROOT=`mktemp -dt acltools`
52
53# Set up the test filesystems.
54MD1=`mdconfig -at swap -s 64m`
55MNT1=$MNTROOT/nfs4
56mkdir $MNT1
57zpool create -m $MNT1 acltools /dev/$MD1
58if [ $? -ne 0 ]; then
59	echo "not ok 1 - 'zpool create' failed."
60	echo 'Bail out!'
61	exit 1
62fi
63
64echo "ok 1"
65
66MD2=`mdconfig -at swap -s 10m`
67MNT2=$MNTROOT/posix
68mkdir $MNT2
69newfs /dev/$MD2 > /dev/null
70mount -o acls /dev/$MD2 $MNT2
71if [ $? -ne 0 ]; then
72	echo "not ok 2 - mount failed."
73	echo 'Bail out!'
74	exit 1
75fi
76
77echo "ok 2"
78
79MD3=`mdconfig -at swap -s 10m`
80MNT3=$MNTROOT/none
81mkdir $MNT3
82newfs /dev/$MD3 > /dev/null
83mount /dev/$MD3 $MNT3
84if [ $? -ne 0 ]; then
85	echo "not ok 3 - mount failed."
86	echo 'Bail out!'
87	exit 1
88fi
89
90echo "ok 3"
91
92cd $MNTROOT
93
94perl $TESTDIR/run $TESTDIR/tools-crossfs.test >&2
95
96if [ $? -eq 0 ]; then
97	echo "ok 4"
98else
99	echo "not ok 4"
100fi
101
102cd /
103
104umount -f $MNT3
105rmdir $MNT3
106mdconfig -du $MD3
107
108umount -f $MNT2
109rmdir $MNT2
110mdconfig -du $MD2
111
112zpool destroy -f acltools
113rmdir $MNT1
114mdconfig -du $MD1
115
116rmdir $MNTROOT
117
118echo "ok 5"
119
120